﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GVB
{
    public partial class ICollBinding : System.Web.UI.Page
    {


        [Serializable]
        public class MiElem
        {
            public string Valor1 { set; get; }
            public int Valor2 { set; get; }
            public DateTime Valor3 { set; get; }
            public bool Valor4 { set; get; }
            public string Valor5 { set; get; }
            public string Valor6 { set; get; }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                ViewState["SortDirectionAsc"] = true;

                List<MiElem> Lst = new List<MiElem>();

                Lst.Add(new MiElem() { Valor1 = "A1", Valor2 = 1, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "L1", Valor2 = 12, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "M1", Valor2 = 13, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "B1", Valor2 = 2, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "C1", Valor2 = 3, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "D1", Valor2 = 4, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "E1", Valor2 = 5, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "F1", Valor2 = 6, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "G1", Valor2 = 7, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "H1", Valor2 = 8, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "I1", Valor2 = 9, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "J1", Valor2 = 10, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "K1", Valor2 = 11, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });
                Lst.Add(new MiElem() { Valor1 = "N1", Valor2 = 14, Valor3 = DateTime.Now, Valor4 = true, Valor5 = "imagen1.gif", Valor6 = @"~\Imagenes\imagen1.gif" });

                ViewState["Lst"] = Lst;
            }
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            BindGrid(GV1);
        }

        protected void GV1_RowDeleting(object sender, GridViewDeleteEventArgs e)
        {
            List<MiElem> Lst = ViewState["Lst"] as List<MiElem>;
            GridView ctlGV = sender as GridView;
            Lst.Remove(Lst.Single(MiE => MiE.Valor1 == (ctlGV.DataKeys[e.RowIndex].Values["Valor1"] as string) && MiE.Valor2 == (int)ctlGV.DataKeys[e.RowIndex].Values["Valor2"]));
            ViewState["Lst"] = Lst;

        }

        protected void GV1_RowEditing(object sender, GridViewEditEventArgs e)
        {
            (sender as GridView).EditIndex = e.NewEditIndex;
        }

        protected void GV1_RowUpdating(object sender, GridViewUpdateEventArgs e)
        {
            GridView ctlGV = sender as GridView;
            TextBox txtCol0_BoundField = ctlGV.Rows[e.RowIndex].Cells[0].Controls[0] as TextBox;
            TextBox txtCol1_ImageField = ctlGV.Rows[e.RowIndex].Cells[1].Controls[0] as TextBox;
            CheckBox txtCol2_CheckBoxField = ctlGV.Rows[e.RowIndex].Cells[2].Controls[0] as CheckBox;
            TextBox txtCol4_TemplateField_txtVV1 = ctlGV.Rows[e.RowIndex].Cells[4].FindControl("txtVV1") as TextBox;

            List<MiElem> Lst = ViewState["Lst"] as List<MiElem>;
            MiElem EditedElem = Lst.Single(MiE => MiE.Valor1 == (ctlGV.DataKeys[e.RowIndex].Values["Valor1"] as string) && MiE.Valor2 == (int)ctlGV.DataKeys[e.RowIndex].Values["Valor2"]);
            EditedElem.Valor5 = txtCol1_ImageField.Text;
            EditedElem.Valor4 = txtCol2_CheckBoxField.Checked;
            if (string.Compare(txtCol0_BoundField.Text, txtCol4_TemplateField_txtVV1.Text) == 1)
                EditedElem.Valor1 = txtCol4_TemplateField_txtVV1.Text;
            else
                EditedElem.Valor1 = txtCol0_BoundField.Text;
            ViewState["Lst"] = Lst;
            (sender as GridView).EditIndex = -1;
        }

        protected void GV1_RowCancelingEdit(object sender, GridViewCancelEditEventArgs e)
        {
            (sender as GridView).EditIndex = -1;
        }

        protected void GV1_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            LblInfo.Text = "Comando: " + e.CommandName + " - Argumento: " + e.CommandArgument as string;
        }

        protected void GV1_Sorting(object sender, GridViewSortEventArgs e)
        {
            string strSortExpression = ViewState["SortExpression"] as string;
            bool blSortDirectionAsc = (bool)ViewState["SortDirectionAsc"];
            if (strSortExpression == e.SortExpression)
                blSortDirectionAsc = !blSortDirectionAsc;
            else
                blSortDirectionAsc = true;

            ViewState["SortExpression"] = e.SortExpression;
            ViewState["SortDirectionAsc"] = blSortDirectionAsc;
            //Deselección de item
            (sender as GridView).SelectedIndex = -1;
        }

        protected void GV1_PageIndexChanging(object sender, GridViewPageEventArgs e)
        {
            ViewState["PageIndex"] = e.NewPageIndex;
            //Deselección de item
            (sender as GridView).SelectedIndex = -1;
        }

        private void BindGrid(GridView Grd)
        {
            string strSortExpression = ViewState["SortExpression"] as string;
            bool blSortDirectionAsc = (bool)ViewState["SortDirectionAsc"];
            int? intPageIndex = ViewState["PageIndex"] as int?;

            switch (strSortExpression)
            {
                case "Valor1":
                    if (blSortDirectionAsc)
                        Grd.DataSource = (ViewState["Lst"] as List<MiElem>).OrderBy(MiE => MiE.Valor1).ToList<MiElem>();
                    else
                        Grd.DataSource = (ViewState["Lst"] as List<MiElem>).OrderByDescending(MiE => MiE.Valor1).ToList<MiElem>();
                    break;
                default:
                    Grd.DataSource = ViewState["Lst"] as List<MiElem>;
                    break;
            }
            if (intPageIndex.HasValue)
                Grd.PageIndex = intPageIndex.Value;
            Grd.DataBind();
        }
        
        protected void GV1_SelectedIndexChanged(object sender, EventArgs e)
        {
            GridView ctlGV = sender as GridView;
            LblInfo.Text += "- Indice: " + ctlGV.SelectedIndex.ToString() + " - DataKey: " + ctlGV.SelectedDataKey["Valor2"] as string + "," + ctlGV.SelectedDataKey["Valor1"] as string;
        }
    }
}